package cokr.xit.fims.excl.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.excl.OpnnSbmsn;
import cokr.xit.fims.crdn.Crdn;
import cokr.xit.fims.excl.ExclQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 의견제출 대장 정보 DAO
 *
 * <p>상세 설명: 의견제출 대장 테이블에 접근하여 데이터를 조회하고 저장한다.
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-06-27	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("opnnSbmsnMapper")
public interface OpnnSbmsnMapper extends AbstractMapper {

	/**지정한 조건에 따라 의견제출 대장 목록을 조회하여 반환한다.<br />
	 * @param req 의견제출 대장 조회 조건
	 * @return 의견제출 대장 목록
	 */
	List<DataObject> selectOpnnSbmsnList(ExclQuery req);

	/**지정한 조건에 따라 의견제출 대장 객체들을 반환한다.
	 * @param req 의견제출 대장 조회 조건
	 * @return 의견제출 대장 객체 목록
	 */
	List<DataObject> selectOpnnSbmsns(ExclQuery req);

	/**지정한 조건에 따라 의견제출 대장 객체의 마지막 1개를 반환한다.
	 * @param opnnId 의견제출 ID
	 * @return 의견제출 대장 객체
	 */
	default DataObject selectOpnnSbmsnInfo(ExclQuery req) {
		List<DataObject> opnnSbmsns = selectOpnnSbmsns(req);

		return !opnnSbmsns.isEmpty() ? opnnSbmsns.get(0) : null;
	}

	/**지정한 단속 ID의 단속, 부과제외 정보를 반환한다.
	 * @param crdnId 단속 ID
	 * @return 단속, 부과제외 정보
	 */
	DataObject selectCrdn(ExclQuery req);

	default DataObject selectCrdnInfo(String crdnId) {
		DataObject crdnInfo = selectCrdn(new ExclQuery().setCrdnId(crdnId));

		return crdnInfo;
	}

	/**의견제출 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"opnnSbmsn" - 의견제출 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertOpnnSbmsn(Map<String, Object> params);

	/**의견제출 대장 정보를 등록한다.
	 * @param opnnSbmsn 의견제출 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(OpnnSbmsn opnnSbmsn) {
		return opnnSbmsn != null && insertOpnnSbmsn(params().set("opnnSbmsn", opnnSbmsn)) == 1;
	}

	/**의견제출 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"opnnSbmsn" - 의견제출 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateOpnnSbmsn(Map<String, Object> params);

	/**의견제출 대장 정보를 수정한다.
	 * @param opnnSbmsn 의견제출 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(OpnnSbmsn opnnSbmsn) {
		return opnnSbmsn != null && updateOpnnSbmsn(params().set("opnnSbmsn", opnnSbmsn)) == 1;
	}

	/**의견제출 심의(결과) 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"opnnSbmsn" - 의견제출 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateAnsSttsCd(Map<String, Object> params);

	/**의견제출 심의(결과) 정보를 수정한다.
	 * @param opnnSbmsn 의견제출 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean updateOpnnSbmsnAnswer(OpnnSbmsn opnnSbmsn) {
		return opnnSbmsn != null && updateAnsSttsCd(params().set("opnnSbmsn", opnnSbmsn)) == 1;
	}

	/**단속 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"crdn" - 단속 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateCrdnOpnnSbmsnYn(Map<String, Object> params);

	/**단속 대장 정보를 수정한다.
	 * @param crdn 단속 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean updateCrdn(Crdn crdn) {
		return crdn != null && updateCrdnOpnnSbmsnYn(params().set("crdn", crdn)) == 1;
	}

	/**지정한 의견제출 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"opnnSbmsn" - 의견제출 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteOpnnSbmsn(Map<String, ?> params);

	/**의견제출 대장 정보를 삭제한다.
	 * @param opnnSbmsn 의견제출 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(OpnnSbmsn opnnSbmsn) {
		return opnnSbmsn != null && deleteOpnnSbmsn(params().set("opnnSbmsn", opnnSbmsn)) == 1;
	}

}
